/*
 * Programming in Java, Jacobs University, 2015
 *
 * This file demonstrates how to implement a simple echo server that
 * accepts incoming client connections and serves each echo client in
 * a separate thread.
 */

import java.io.Reader;
import java.io.Writer;
import java.io.IOException;
import java.net.Socket;
import java.net.ServerSocket;

public class EchoServer
{
    static final int PORT = 4321;
    
    public static void main(String[] args)
	throws IOException
    {
	ServerSocket s = new ServerSocket(PORT);
	try {
	    while (true) {
		Socket socket = s.accept();
		try {
		    Runnable r = new ServeEchoClient(socket);
		    Thread t = new Thread(r);
		    t.start();
		} catch(IOException e) {
		    socket.close();
		}
	    }
	} finally {
	    s.close();
	}
    }
}
